diff --git a/plugins/move.c b/plugins/move.c
index 32fb456..d66f17a 100644
--- a/plugins/move.c
+++ b/plugins/move.c
@@ -28,8 +28,10 @@
 #include <string.h>
 
 #include <X11/cursorfont.h>
+#include <X11/Xatom.h>
 
 #include <compiz-core.h>
+#include <decoration.h>
 
 static CompMetadata moveMetadata;
 
@@ -51,6 +53,11 @@ struct _MoveKeys {
 #define SNAP_BACK 20
 #define SNAP_OFF  100
 
+typedef struct _MoveBox {
+    decor_point_t p1;
+    decor_point_t p2;
+} MoveBox;
+
 static int displayPrivateIndex;
 
 #define MOVE_DISPLAY_OPTION_INITIATE_BUTTON   0
@@ -76,12 +83,17 @@ typedef struct _MoveDisplay {
     int        status;
     KeyCode    key[NUM_KEYS];
 
+    Atom moveAtom;
+    Atom moveNotifyAtom;
+
     int releaseButton;
 
     GLushort moveOpacity;
 } MoveDisplay;
 
 typedef struct _MoveScreen {
+    int windowPrivateIndex;
+
     PaintWindowProc paintWindow;
 
     int grabIndex;
@@ -94,6 +106,12 @@ typedef struct _MoveScreen {
     int	snapBackY;
 } MoveScreen;
 
+typedef struct _MoveWindow {
+    int     button;
+    MoveBox *box;
+    int     nBox;
+} MoveWindow;
+
 #define GET_MOVE_DISPLAY(d)					  \
     ((MoveDisplay *) (d)->base.privates[displayPrivateIndex].ptr)
 
@@ -106,8 +124,106 @@ typedef struct _MoveScreen {
 #define MOVE_SCREEN(s)						        \
     MoveScreen *ms = GET_MOVE_SCREEN (s, GET_MOVE_DISPLAY (s->display))
 
+#define GET_MOVE_WINDOW(w, ms)					      \
+    ((MoveWindow *) (w)->base.privates[(ms)->windowPrivateIndex].ptr)
+
+#define MOVE_WINDOW(w)					     \
+    MoveWindow *mw = GET_MOVE_WINDOW  (w,		     \
+		     GET_MOVE_SCREEN  (w->screen,	     \
+		     GET_MOVE_DISPLAY (w->screen->display)))
+
+
 #define NUM_OPTIONS(s) (sizeof ((s)->opt) / sizeof (CompOption))
 
+
+static Bool
+movePointInBoxes (int     x,
+		  int     y,
+		  MoveBox *box,
+		  int	  nBox,
+		  int	  width,
+		  int	  height)
+{
+    int x0, y0, x1, y1;
+
+    while (nBox--)
+    {
+	decor_apply_gravity (box->p1.gravity, box->p1.x, box->p1.y,
+			     width, height,
+			     &x0, &y0);
+
+	decor_apply_gravity (box->p2.gravity, box->p2.x, box->p2.y,
+			     width, height,
+			     &x1, &y1);
+
+	if (x >= x0 && x < x1 && y >= y0 && y < y1)
+	    return TRUE;
+
+	box++;
+    }
+
+    return FALSE;
+}
+
+static void
+moveWindowUpdate (CompWindow *w)
+{
+    Atom	  actual;
+    int		  result, format;
+    unsigned long n, left;
+    unsigned char *propData;
+    MoveBox	  *box = NULL;
+    int		  nBox = 0;
+
+    MOVE_DISPLAY (w->screen->display);
+    MOVE_WINDOW (w);
+
+    result = XGetWindowProperty (w->screen->display->display, w->id,
+				 md->moveAtom, 0L, 8192L, FALSE,
+				 XA_INTEGER, &actual, &format,
+				 &n, &left, &propData);
+
+    if (result == Success && n && propData)
+    {
+	if (n >= 2)
+	{
+	    long *data = (long *) propData;
+
+	    mw->button = data[1];
+
+	    nBox = (n - 2) / 6;
+	    if (nBox)
+	    {
+		box = malloc (sizeof (MoveBox) * nBox);
+		if (box)
+		{
+		    int i;
+
+		    data += 2;
+
+		    for (i = 0; i < nBox; i++)
+		    {
+			box[i].p1.gravity = *data++;
+			box[i].p1.x       = *data++;
+			box[i].p1.y       = *data++;
+			box[i].p2.gravity = *data++;
+			box[i].p2.x       = *data++;
+			box[i].p2.y       = *data++;
+		    }
+		}
+	    }
+	}
+
+	XFree (propData);
+    }
+
+    if (mw->box)
+	free (mw->box);
+
+    mw->box  = box;
+    mw->nBox = nBox;
+}
+
 static Bool
 moveInitiate (CompDisplay     *d,
 	      CompAction      *action,
@@ -125,18 +241,25 @@ moveInitiate (CompDisplay     *d,
     w = findWindowAtDisplay (d, xid);
     if (w && (w->actions & CompWindowActionMoveMask))
     {
+	CompWindow   *p;
 	XRectangle   workArea;
 	unsigned int mods;
 	int          x, y, button;
 
 	MOVE_SCREEN (w->screen);
 
+	x = w->width / 2;
+	y = w->height / 2;
+	for (p = w; p; p = p->parent)
+	{
+	    x += p->attrib.x;
+	    y += p->attrib.y;
+	}
+
 	mods = getIntOptionNamed (option, nOption, "modifiers", 0);
 
-	x = getIntOptionNamed (option, nOption, "x",
-			       w->attrib.x + (w->width / 2));
-	y = getIntOptionNamed (option, nOption, "y",
-			       w->attrib.y + (w->height / 2));
+	x = getIntOptionNamed (option, nOption, "x", x);
+	y = getIntOptionNamed (option, nOption, "y", y);
 
 	button = getIntOptionNamed (option, nOption, "button", -1);
 
@@ -192,6 +315,12 @@ moveInitiate (CompDisplay     *d,
 
 	    md->releaseButton = button;
 
+	    for (p = w->parent; p; p = p->parent)
+	    {
+		x -= p->attrib.x;
+		y -= p->attrib.y;
+	    }
+
 	    (w->screen->windowGrabNotify) (w, x, y, mods,
 					   CompWindowGrabMoveMask |
 					   CompWindowGrabButtonMask);
@@ -208,6 +337,8 @@ moveInitiate (CompDisplay     *d,
 
 	    if (md->moveOpacity != OPAQUE)
 		addWindowDamage (w);
+
+	    return TRUE;
 	}
     }
 
@@ -298,7 +429,7 @@ moveGetYConstrainRegion (CompScreen *s)
 	getWorkareaForOutput (s, i, &workArea);
 	extents = s->outputDev[i].region.extents;
 
-	for (w = s->windows; w; w = w->next)
+	for (w = s->root.windows; w; w = w->next)
 	{
 	    if (!w->mapNum)
 		continue;
@@ -534,12 +665,18 @@ moveHandleMotionEvent (CompScreen *s,
 
 	if (dx || dy)
 	{
+	    Bool lazy = md->opt[MOVE_DISPLAY_OPTION_LAZY_POSITIONING].value.b;
+
 	    moveWindow (w,
 			wX + dx - w->attrib.x,
 			wY + dy - w->attrib.y,
 			TRUE, FALSE);
 
-	    if (md->opt[MOVE_DISPLAY_OPTION_LAZY_POSITIONING].value.b)
+	    /* lazy positioning cannot be used without manual compositing */
+	    if (!manualCompositeManagement)
+		lazy = FALSE;
+
+	    if (lazy)
 	    {
 		/* FIXME: This form of lazy positioning is broken and should
 		   be replaced asap. Current code exists just to avoid a
@@ -563,11 +700,85 @@ moveHandleEvent (CompDisplay *d,
 		 XEvent      *event)
 {
     CompScreen *s;
+    CompWindow *w;
 
     MOVE_DISPLAY (d);
 
     switch (event->type) {
     case ButtonPress:
+	w = findClientWindowAtDisplay (d, event->xbutton.window);
+	if (w)
+	{
+	    CompWindow *p;
+	    int        option = MOVE_DISPLAY_OPTION_INITIATE_BUTTON;
+	    int        x = event->xbutton.x_root;
+	    int        y = event->xbutton.y_root;
+
+	    MOVE_WINDOW (w);
+
+	    for (p = w; p; p = p->parent)
+	    {
+		x -= p->attrib.x;
+		y -= p->attrib.y;
+	    }
+
+	    if (event->xbutton.button == mw->button &&
+		movePointInBoxes (x, y,
+				  mw->box, mw->nBox,
+				  w->width, w->height))
+	    {
+		CompOption o[5];
+
+		o[0].type    = CompOptionTypeInt;
+		o[0].name    = "window";
+		o[0].value.i = w->id;
+
+		o[1].type    = CompOptionTypeInt;
+		o[1].name    = "modifiers";
+		o[1].value.i = event->xbutton.state;
+
+		o[2].type    = CompOptionTypeInt;
+		o[2].name    = "x";
+		o[2].value.i = event->xbutton.x_root;
+
+		o[3].type    = CompOptionTypeInt;
+		o[3].name    = "y";
+		o[3].value.i = event->xbutton.y_root;
+
+		o[4].type    = CompOptionTypeInt;
+		o[4].name    = "button";
+		o[4].value.i = event->xbutton.button;
+
+		if (moveInitiate (d,
+				  &md->opt[option].value.action,
+				  CompActionStateInitButton,
+				  o, 5))
+		{
+		    XEvent ev;
+		    int    mask = NoEventMask;
+
+		    if (!w->parent->substructureRedirect)
+			activateWindow (w);
+
+		    if (w->parent == &w->screen->root)
+			mask = SubstructureRedirectMask |
+			    SubstructureNotifyMask;
+
+		    ev.type		    = ClientMessage;
+		    ev.xclient.window	    = event->xbutton.subwindow;
+		    ev.xclient.message_type = md->moveNotifyAtom;
+		    ev.xclient.format	    = 32;
+		    ev.xclient.data.l[0]    = event->xbutton.button;
+		    ev.xclient.data.l[1]    = event->xbutton.x;
+		    ev.xclient.data.l[2]    = event->xbutton.y;
+		    ev.xclient.data.l[3]    = event->xbutton.time;
+		    ev.xclient.data.l[4]    = 0;
+
+		    XSendEvent (d->display, w->parent->id, FALSE, mask, &ev);
+		}
+	    }
+	}
+	break;
     case ButtonRelease:
 	s = findScreenAtDisplay (d, event->xbutton.root);
 	if (s)
@@ -626,8 +837,6 @@ moveHandleEvent (CompDisplay *d,
     case ClientMessage:
 	if (event->xclient.message_type == d->wmMoveResizeAtom)
 	{
-	    CompWindow *w;
-
 	    if (event->xclient.data.l[2] == WmMoveResizeMove ||
 		event->xclient.data.l[2] == WmMoveResizeMoveKeyboard)
 	    {
@@ -658,7 +867,7 @@ moveHandleEvent (CompDisplay *d,
 
 			option = MOVE_DISPLAY_OPTION_INITIATE_BUTTON;
 
-			XQueryPointer (d->display, w->screen->root,
+			XQueryPointer (d->display, w->screen->root.id,
 				       &root, &child, &xRoot, &yRoot,
 				       &i, &i, &mods);
 
@@ -709,6 +918,14 @@ moveHandleEvent (CompDisplay *d,
 		}
 	    }
 	}
+	else if (event->xclient.message_type == md->moveNotifyAtom)
+	{
+	    /* forward to owner */
+	    XSendEvent (d->display,
+			event->xclient.window,
+			FALSE, NoEventMask,
+			event);
+	}
 	break;
     case DestroyNotify:
 	if (md->w && md->w->id == event->xdestroywindow.window)
@@ -746,6 +963,18 @@ moveHandleEvent (CompDisplay *d,
     UNWRAP (md, d, handleEvent);
     (*d->handleEvent) (d, event);
     WRAP (md, d, handleEvent, moveHandleEvent);
+
+    if (event->type == PropertyNotify)
+    {
+	if (event->xproperty.atom == md->moveAtom)
+	{
+	    CompWindow *w;
+
+	    w = findWindowAtDisplay (d, event->xproperty.window);
+	    if (w)
+		moveWindowUpdate (w);
+	}
+    }
 }
 
 static Bool
@@ -876,6 +1105,13 @@ moveInitDisplay (CompPlugin  *p,
 	md->key[i] = XKeysymToKeycode (d->display,
 				       XStringToKeysym (mKeys[i].name));
 
+    md->moveAtom       = XInternAtom (d->display,
+				      "_COMPIZ_WM_WINDOW_MOVE_DECOR",
+				      0);
+    md->moveNotifyAtom = XInternAtom (d->display,
+				      "_COMPIZ_WM_WINDOW_MOVE_DECOR_NOTIFY",
+				      0);
+
     WRAP (md, d, handleEvent, moveHandleEvent);
 
     d->base.privates[displayPrivateIndex].ptr = md;
@@ -910,6 +1146,13 @@ moveInitScreen (CompPlugin *p,
     if (!ms)
 	return FALSE;
 
+    ms->windowPrivateIndex = allocateWindowPrivateIndex (s);
+    if (ms->windowPrivateIndex < 0)
+    {
+	free (ms);
+	return FALSE;
+    }
+
     ms->grabIndex = 0;
 
     ms->moveCursor = XCreateFontCursor (s->display->display, XC_fleur);
@@ -932,9 +1175,46 @@ moveFiniScreen (CompPlugin *p,
     if (ms->moveCursor)
 	XFreeCursor (s->display->display, ms->moveCursor);
 
+    freeWindowPrivateIndex (s, ms->windowPrivateIndex);
+
     free (ms);
 }
 
+static Bool
+moveInitWindow (CompPlugin *p,
+		CompWindow *w)
+{
+    MoveWindow *mw;
+
+    MOVE_SCREEN (w->screen);
+
+    mw = malloc (sizeof (MoveWindow));
+    if (!mw)
+	return FALSE;
+
+    mw->button = 0;
+    mw->box    = NULL;
+    mw->nBox   = 0;
+
+    w->base.privates[ms->windowPrivateIndex].ptr = mw;
+
+    moveWindowUpdate (w);
+
+    return TRUE;
+}
+
+static void
+moveFiniWindow (CompPlugin *p,
+		CompWindow *w)
+{
+    MOVE_WINDOW (w);
+
+    if (mw->box)
+	free (mw->box);
+
+    free (mw);
+}
+
 static CompBool
 moveInitObject (CompPlugin *p,
 		CompObject *o)
@@ -942,7 +1222,8 @@ moveInitObject (CompPlugin *p,
     static InitPluginObjectProc dispTab[] = {
 	(InitPluginObjectProc) 0, /* InitCore */
 	(InitPluginObjectProc) moveInitDisplay,
-	(InitPluginObjectProc) moveInitScreen
+	(InitPluginObjectProc) moveInitScreen,
+	(InitPluginObjectProc) moveInitWindow
     };
 
     RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), TRUE, (p, o));
@@ -955,7 +1236,8 @@ moveFiniObject (CompPlugin *p,
     static FiniPluginObjectProc dispTab[] = {
 	(FiniPluginObjectProc) 0, /* FiniCore */
 	(FiniPluginObjectProc) moveFiniDisplay,
-	(FiniPluginObjectProc) moveFiniScreen
+	(FiniPluginObjectProc) moveFiniScreen,
+	(FiniPluginObjectProc) moveFiniWindow
     };
 
     DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), (p, o));
diff --git a/plugins/obs.c b/plugins/obs.c
index bec8136..d526772 100644
--- a/plugins/obs.c
+++ b/plugins/obs.c
@@ -75,7 +75,6 @@ typedef struct _ObsScreen
     int windowPrivateIndex;
 
     PaintWindowProc paintWindow;
-    DrawWindowProc  drawWindow;
 
     CompOption *stepOptions[MODIFIER_COUNT];
     CompOption *matchOptions[MODIFIER_COUNT];
@@ -210,76 +209,32 @@ obsPaintWindow (CompWindow              *w,
 		Region                  region,
 		unsigned int            mask)
 {
-    CompScreen *s = w->screen;
-    Bool       status;
+    WindowPaintAttrib wAttrib = *attrib;
+    CompScreen        *s = w->screen;
+    int               factor;
+    Bool              status;
 
     OBS_SCREEN (s);
     OBS_WINDOW (w);
 
-    if (ow->customFactor[MODIFIER_OPACITY] != 100)
-	mask |= PAINT_WINDOW_TRANSLUCENT_MASK;
-
-    UNWRAP (os, s, paintWindow);
-    status = (*s->paintWindow) (w, attrib, transform, region, mask);
-    WRAP (os, s, paintWindow, obsPaintWindow);
-
-    return status;
-}
-
-/* Note: Normally plugins should wrap into PaintWindow to modify opacity,
-	 brightness and saturation. As some plugins bypass paintWindow when
-	 they draw windows and our custom values always need to be applied,
-	 we wrap into DrawWindow here */
-
-static Bool
-obsDrawWindow (CompWindow           *w,
-	       const CompTransform  *transform,
-	       const FragmentAttrib *attrib,
-	       Region               region,
-	       unsigned int         mask)
-{
-    CompScreen *s = w->screen;
-    Bool       hasCustomFactor = FALSE;
-    Bool       status;
-    int        i;
-
-    OBS_SCREEN (s);
-    OBS_WINDOW (w);
-
-    for (i = 0; i < MODIFIER_COUNT; i++)
-	if (ow->customFactor[i] != 100)
-	{
-	    hasCustomFactor = TRUE;
-	    break;
-	}
-
-    if (hasCustomFactor)
+    factor = ow->customFactor[MODIFIER_OPACITY];
+    if (factor != 100)
     {
-	FragmentAttrib fragment = *attrib;
-	int            factor;
-
-	factor = ow->customFactor[MODIFIER_OPACITY];
-	if (factor != 100)
-	    fragment.opacity = (int) fragment.opacity * factor / 100;
+	wAttrib.opacity = (int) wAttrib.opacity * factor / 100;
+	mask |= PAINT_WINDOW_TRANSLUCENT_MASK;
+    }
 
-	factor = ow->customFactor[MODIFIER_BRIGHTNESS];
-	if (factor != 100)
-	    fragment.brightness = (int) fragment.brightness * factor / 100;
+    factor = ow->customFactor[MODIFIER_BRIGHTNESS];
+    if (factor != 100)
+	wAttrib.brightness = (int) wAttrib.brightness * factor / 100;
 
-	factor = ow->customFactor[MODIFIER_SATURATION];
-	if (factor != 100)
-	    fragment.saturation = (int) fragment.saturation * factor / 100;
+    factor = ow->customFactor[MODIFIER_SATURATION];
+    if (factor != 100)
+	wAttrib.saturation = (int) wAttrib.saturation * factor / 100;
 
-	UNWRAP (os, s, drawWindow);
-	status = (*s->drawWindow) (w, transform, &fragment, region, mask);
-	WRAP (os, s, drawWindow, obsDrawWindow);
-    }
-    else
-    {
-	UNWRAP (os, s, drawWindow);
-	status = (*s->drawWindow) (w, transform, attrib, region, mask);
-	WRAP (os, s, drawWindow, obsDrawWindow);
-    }
+    UNWRAP (os, s, paintWindow);
+    status = (*s->paintWindow) (w, &wAttrib, transform, region, mask);
+    WRAP (os, s, paintWindow, obsPaintWindow);
 
     return status;
 }
@@ -299,7 +254,7 @@ obsMatchExpHandlerChanged (CompDisplay *d)
 
     /* match options are up to date after the call to matchExpHandlerChanged */
     for (s = d->screens; s; s = s->next)
-	for (w = s->windows; w; w = w->next)
+	for (w = s->root.windows; w; w = w->next)
 	    for (i = 0; i < MODIFIER_COUNT; i++)
 		updatePaintModifier (w, i);
 }
@@ -386,7 +341,7 @@ obsSetScreenOption (CompPlugin      *p,
 		for (j = 0; j < o->value.list.nValue; j++)
 		    matchUpdate (s->display, &o->value.list.value[j].match);
 
-		for (w = s->windows; w; w = w->next)
+		for (w = s->root.windows; w; w = w->next)
 		    updatePaintModifier (w, i);
 
 		return TRUE;
@@ -398,7 +353,7 @@ obsSetScreenOption (CompPlugin      *p,
 	    {
 		CompWindow *w;
 
-		for (w = s->windows; w; w = w->next)
+		for (w = s->root.windows; w; w = w->next)
 		    updatePaintModifier (w, i);
 
 		return TRUE;
@@ -599,7 +554,6 @@ obsInitScreen (CompPlugin *p,
     s->base.privates[od->screenPrivateIndex].ptr = os;
 
     WRAP (os, s, paintWindow, obsPaintWindow);
-    WRAP (os, s, drawWindow, obsDrawWindow);
 
     return TRUE;
 }
@@ -611,7 +565,6 @@ obsFiniScreen (CompPlugin *p,
     OBS_SCREEN (s);
 
     UNWRAP (os, s, paintWindow);
-    UNWRAP (os, s, drawWindow);
 
     damageScreen (s);
     
diff --git a/plugins/place.c b/plugins/place.c
index 596a3a5..6c9a8e4 100644
--- a/plugins/place.c
+++ b/plugins/place.c
@@ -257,7 +257,7 @@ placeSendWindowMaximizationRequest (CompWindow *w)
     xev.xclient.data.l[3] = 0;
     xev.xclient.data.l[4] = 0;
 
-    XSendEvent (d->display, w->screen->root, FALSE,
+    XSendEvent (d->display, w->screen->root.id, FALSE,
 		SubstructureRedirectMask | SubstructureNotifyMask, &xev);
 }
 
@@ -681,7 +681,7 @@ placeCascade (CompWindow *w,
     unsigned int count = 0;
 
     /* get the total window count */
-    for (wi = w->screen->windows; wi; wi = wi->next)
+    for (wi = w->screen->root.windows; wi; wi = wi->next)
 	count++;
 
     windows = malloc (sizeof (CompWindow *) * count);
@@ -692,7 +692,7 @@ placeCascade (CompWindow *w,
      * as placed window, may be shaded - if shaded we pretend it isn't
      * for placement purposes)
      */
-    for (wi = w->screen->windows, count = 0; wi; wi = wi->next)
+    for (wi = w->screen->root.windows, count = 0; wi; wi = wi->next)
     {
 	if (!IS_PLACE_RELEVANT (wi, w))
 	    continue;
@@ -813,7 +813,7 @@ placeSmart (CompWindow *w,
 	    cyt = yTmp;
 	    cyb = yTmp + ch;
 
-	    for (wi = w->screen->windows; wi; wi = wi->next)
+	    for (wi = w->screen->root.windows; wi; wi = wi->next)
 	    {
 		if (!IS_PLACE_RELEVANT (wi, w))
 		    continue;
@@ -871,7 +871,7 @@ placeSmart (CompWindow *w,
 		possible -= cw;
 
 	    /* compare to the position of each client on the same desk */
-	    for (wi = w->screen->windows; wi; wi = wi->next)
+	    for (wi = w->screen->root.windows; wi; wi = wi->next)
 	    {
 		if (!IS_PLACE_RELEVANT (wi, w))
 		    continue;
@@ -906,7 +906,7 @@ placeSmart (CompWindow *w,
 		possible -= ch;
 
 	    /* test the position of each window on the desk */
-	    for (wi = w->screen->windows; wi; wi = wi->next)
+	    for (wi = w->screen->root.windows; wi; wi = wi->next)
 	    {
 		if (!IS_PLACE_RELEVANT (wi, w))
 		    continue;
@@ -1016,7 +1016,7 @@ placeGetPlacementOutput (CompWindow        *w,
 	{
 	    CompWindow *parent;
 
-	    parent = findWindowAtScreen (s, w->transientFor);
+	    parent = findSibling (w, w->transientFor);
 	    if (parent)
 		output = outputDeviceForWindow (parent);
 	}
@@ -1047,7 +1047,7 @@ placeGetPlacementOutput (CompWindow        *w,
 	    /* this means a server roundtrip, which kind of sucks; thus
 	       this code should be replaced as soon as we have software
 	       cursor rendering and thus have a cached pointer coordinate */
-	    if (XQueryPointer (s->display->display, s->root,
+	    if (XQueryPointer (s->display->display, s->root.id,
 			       &wDummy, &wDummy, &xPointer, &yPointer,
 			       &iDummy, &iDummy, &uiDummy))
 	    {
@@ -1085,21 +1085,31 @@ placeConstrainToWorkarea (CompWindow *w,
 			  int        *y)
 {
     CompWindowExtents extents;
+    int               delta;
 
     extents.left   = *x - w->input.left;
     extents.top    = *y - w->input.top;
     extents.right  = *x + w->serverWidth + w->input.right;
     extents.bottom = *y + w->serverHeight + w->input.bottom;
 
-    if (extents.left < workArea->x)
-	*x += workArea->x - extents.left;
-    else if (extents.right > workArea->x + workArea->width)
-	*x += workArea->x + workArea->width - extents.right;
+    delta = workArea->x + workArea->width - extents.right;
+    if (delta < 0)
+	extents.left += delta;
 
-    if (extents.top < workArea->y)
-	*y += workArea->y - extents.top;
-    else if (extents.bottom > workArea->y + workArea->height)
-	*y += workArea->y + workArea->height - extents.bottom;
+    delta = workArea->x - extents.left;
+    if (delta > 0)
+    	extents.left  += delta;
+
+    delta = workArea->y + workArea->height - extents.bottom;
+    if (delta < 0)
+	extents.top += delta;
+
+    delta = workArea->y - extents.top;
+    if (delta > 0)
+    	extents.top += delta;
+
+    *x = extents.left + w->input.left;
+    *y = extents.top  + w->input.top;
 }
 
 static Bool
@@ -1138,7 +1148,7 @@ placeDoWindowPlacement (CompWindow *w,
     {
 	CompWindow *parent;
 
-	parent = findWindowAtScreen (s, w->transientFor);
+	parent = findSibling (w, w->transientFor);
 	if (parent)
 	{
 	    /* center over parent horizontally */
@@ -1443,7 +1453,8 @@ placeInitDisplay (CompPlugin  *p,
 {
     PlaceDisplay *pd;
 
-    if (!checkPluginABI ("core", CORE_ABIVERSION))
+    if (!checkPluginABI ("core", CORE_ABIVERSION) ||
+	!checkPluginABI ("wm",   CORE_ABIVERSION))
 	return FALSE;
 
     pd = malloc (sizeof (PlaceDisplay));
diff --git a/plugins/resize.c b/plugins/resize.c
index 5b8b12b..d2de79b 100644
--- a/plugins/resize.c
+++ b/plugins/resize.c
@@ -269,7 +269,7 @@ resizeSendResizeNotify (CompDisplay *d)
     xev.xclient.data.l[4] = 0;
 
     XSendEvent (d->display,
-		rd->w->screen->root,
+		rd->w->screen->root.id,
 		FALSE,
 		SubstructureRedirectMask | SubstructureNotifyMask,
 		&xev);
@@ -438,6 +438,10 @@ resizeInitiate (CompDisplay     *d,
 	    }
 	}
 
+	/* only normal resize mode can be used without manual compositing */
+	if (!manualCompositeManagement)
+	    rd->mode = RESIZE_MODE_NORMAL;
+
 	if (!rs->grabIndex)
 	{
 	    Cursor cursor;
@@ -900,7 +904,7 @@ resizeHandleEvent (CompDisplay *d,
 
 			option = RESIZE_DISPLAY_OPTION_INITIATE_BUTTON;
 
-			XQueryPointer (d->display, w->screen->root,
+			XQueryPointer (d->display, w->screen->root.id,
 				       &root, &child, &xRoot, &yRoot,
 				       &i, &i, &mods);
 
diff --git a/plugins/rotate.c b/plugins/rotate.c
index 8b76d4d..1369d62 100644
--- a/plugins/rotate.c
+++ b/plugins/rotate.c
@@ -368,7 +368,37 @@ rotatePreparePaintScreen (CompScreen *s,
 		    /* flag end of rotation */
 		    cs->rotationState = RotationNone;
 
-		    moveScreenViewport (s, tx, 0, TRUE);
+		    if (s->root.substructureRedirect)
+		    {
+			moveScreenViewport (s, tx, 0, TRUE);
+		    }
+		    else
+		    {
+			CompDisplay *d = s->display;
+			XEvent      xev;
+
+			xev.xclient.type    = ClientMessage;
+			xev.xclient.display = d->display;
+			xev.xclient.format  = 32;
+
+			xev.xclient.message_type = d->desktopViewportAtom;
+			xev.xclient.window	 = s->root.id;
+
+			xev.xclient.data.l[0] = (s->x - tx) * s->width;
+			xev.xclient.data.l[1] = s->y * s->height;
+			xev.xclient.data.l[2] = 0;
+			xev.xclient.data.l[3] = 0;
+			xev.xclient.data.l[4] = 0;
+
+			XSendEvent (s->display->display,
+				    s->root.id,
+				    FALSE,
+				    SubstructureRedirectMask |
+				    SubstructureNotifyMask,
+				    &xev);
+
+			moveScreenViewport (s, tx, 0, FALSE);
+		    }
 
 		    rs->xrot = 0.0f;
 		    rs->yrot = 0.0f;
@@ -680,7 +710,7 @@ rotateTerminate (CompDisplay     *d,
     {
 	ROTATE_SCREEN (s);
 
-	if (xid && s->root != xid)
+	if (xid && s->root.id != xid)
 	    continue;
 
 	if (rs->grabIndex)
@@ -750,7 +780,7 @@ rotate (CompDisplay     *d,
 
 	    o[2].type	 = CompOptionTypeInt;
 	    o[2].name	 = "root";
-	    o[2].value.i = s->root;
+	    o[2].value.i = s->root.id;
 
 	    rotateInitiate (d, NULL, 0, o, 3);
 	}
@@ -839,7 +869,7 @@ rotateWithWindow (CompDisplay     *d,
 
 	    o[2].type	 = CompOptionTypeInt;
 	    o[2].name	 = "root";
-	    o[2].value.i = s->root;
+	    o[2].value.i = s->root.id;
 
 	    rotateInitiate (d, NULL, 0, o, 3);
 	}
@@ -1014,7 +1044,7 @@ rotateFlipLeft (void *closure)
 
     o[2].type	 = CompOptionTypeInt;
     o[2].name	 = "root";
-    o[2].value.i = s->root;
+    o[2].value.i = s->root.id;
 
     o[3].type	 = CompOptionTypeInt;
     o[3].name	 = "direction";
@@ -1059,7 +1089,7 @@ rotateFlipRight (void *closure)
 
     o[2].type	 = CompOptionTypeInt;
     o[2].name	 = "root";
-    o[2].value.i = s->root;
+    o[2].value.i = s->root.id;
 
     o[3].type	 = CompOptionTypeInt;
     o[3].name	 = "direction";
@@ -1139,7 +1169,7 @@ rotateEdgeFlip (CompScreen      *s,
 
     o[2].type	 = CompOptionTypeInt;
     o[2].name	 = "root";
-    o[2].value.i = s->root;
+    o[2].value.i = s->root.id;
 
     o[3].type	 = CompOptionTypeInt;
     o[3].name	 = "direction";
@@ -1256,7 +1286,7 @@ rotateFlipTerminate (CompDisplay     *d,
     {
 	ROTATE_SCREEN (s);
 
-	if (xid && s->root != xid)
+	if (xid && s->root.id != xid)
 	    continue;
 
 	if (rs->rotateHandle)
@@ -1383,7 +1413,7 @@ rotateTo (CompDisplay     *d,
 
 	o[2].type    = CompOptionTypeInt;
 	o[2].name    = "root";
-	o[2].value.i = s->root;
+	o[2].value.i = s->root.id;
 
 	o[3].type    = CompOptionTypeInt;
 	o[3].name    = "direction";
@@ -1443,7 +1473,7 @@ rotateToWithWindow (CompDisplay     *d,
 
 	o[2].type    = CompOptionTypeInt;
 	o[2].name    = "root";
-	o[2].value.i = s->root;
+	o[2].value.i = s->root.id;
 
 	o[3].type    = CompOptionTypeInt;
 	o[3].name    = "direction";
@@ -1464,6 +1494,7 @@ rotateHandleEvent (CompDisplay *d,
 		   XEvent      *event)
 {
     CompScreen *s;
+    int        dx = 0;
 
     ROTATE_DISPLAY (d);
 
@@ -1512,13 +1543,14 @@ rotateHandleEvent (CompDisplay *d,
 	}
 	break;
     case ClientMessage:
+	if (!windowManagement)
+	    break;
+
 	if (event->xclient.message_type == d->desktopViewportAtom)
 	{
 	    s = findScreenAtDisplay (d, event->xclient.window);
 	    if (s)
 	    {
-		int dx;
-
 		ROTATE_SCREEN (s);
 
 		if (otherScreenGrabExist (s, "rotate", "switcher", "cube", 0))
@@ -1535,7 +1567,7 @@ rotateHandleEvent (CompDisplay *d,
 		    unsigned int ui;
 		    CompOption   o[4];
 
-		    XQueryPointer (d->display, s->root,
+		    XQueryPointer (d->display, s->root.id,
 				   &win, &win, &x, &y, &i, &i, &ui);
 
 		    if (dx * 2 > s->hsize)
@@ -1553,7 +1585,7 @@ rotateHandleEvent (CompDisplay *d,
 
 		    o[2].type	 = CompOptionTypeInt;
 		    o[2].name	 = "root";
-		    o[2].value.i = s->root;
+		    o[2].value.i = s->root.id;
 
 		    o[3].type	 = CompOptionTypeInt;
 		    o[3].name	 = "direction";
@@ -1570,6 +1602,29 @@ rotateHandleEvent (CompDisplay *d,
     UNWRAP (rd, d, handleEvent);
     (*d->handleEvent) (d, event);
     WRAP (rd, d, handleEvent, rotateHandleEvent);
+
+    switch (event->type) {
+    case ClientMessage:
+	if (!dx)
+	    break;
+
+	if (event->xclient.message_type == d->desktopViewportAtom)
+	{
+	    s = findScreenAtDisplay (d, event->xclient.window);
+	    if (s)
+	    {
+		ROTATE_SCREEN (s);
+
+		if (rs->moving)
+		{
+		    rs->moveTo   += (360.0f / s->hsize) * -dx;
+		    rs->baseXrot += (360.0f / s->hsize) * dx;
+		}
+	    }
+	}
+    default:
+	break;
+    }
 }
 
 static void
@@ -1596,7 +1651,7 @@ rotateActivateWindow (CompWindow *w)
 	    unsigned int ui;
 	    CompOption   o[5];
 
-	    XQueryPointer (s->display->display, s->root,
+	    XQueryPointer (s->display->display, s->root.id,
 			   &win, &win, &x, &y, &i, &i, &ui);
 
 	    if (dx * 2 > s->hsize)
@@ -1614,7 +1669,7 @@ rotateActivateWindow (CompWindow *w)
 
 	    o[2].type    = CompOptionTypeInt;
 	    o[2].name    = "root";
-	    o[2].value.i = s->root;
+	    o[2].value.i = s->root.id;
 
 	    o[3].type    = CompOptionTypeInt;
 	    o[3].name    = "direction";
